/*
 *
 * new Font
 *
 * created with FontCreator
 * written by F. Maximilian Thiele
 *
 * http://www.apetech.de/fontCreator
 * me@apetech.de
 *
 * File Name           : VerdanaNumbers.h
 * Date                : 26.08.2010
 * Font size in bytes  : 3539
 * Font width          : 10
 * Font height         : 21
 * Font first char     : 48
 * Font last char      : 59
 * Font used chars     : 11
 *
 * The font data are defined as
 *
 * struct _FONT_ {
 *     uint16_t   font_Size_in_Bytes_over_all_included_Size_it_self;
 *     uint8_t    font_Width_in_Pixel_for_fixed_drawing;
 *     uint8_t    font_Height_in_Pixel_for_all_characters;
 *     unit8_t    font_First_Char;
 *     uint8_t    font_Char_Count;
 *
 *     uint8_t    font_Char_Widths[font_Last_Char - font_First_Char +1];
 *                  // for each character the separate width in pixels,
 *                  // characters < 128 have an implicit virtual right empty row
 *
 *     uint8_t    font_data[];
 *                  // bit field of all characters
 */

#ifndef NEW_FONT_H
#define NEW_FONT_H

#define NEW_FONT_WIDTH 10
#define NEW_FONT_HEIGHT 21

const unsigned char VerdanaNumbers[] = {
    0x0D, 0xD3, // size
    0x0A, // width
    0x15, // height
    0x30, // first char
    0x0C, // char count
    
    // char widths
    0x10, 0x0D, 0x10, 0x10, 0x12, 0x10, 0x11, 0x10, 0x12, 0x11, 
    0x05, 0x05,
    
    // font data
    0xC0, 0xF8, 0xFC, 0xFE, 0xFE, 0x3F, 0x0F, 0x0F, 0x0F, 0x0F, 0x3F, 0xFE, 0xFE, 0xFC, 0xF8, 0xC0, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, 0x80, 0xFF, 0xFF, 0xFF, 0xFF, 0x7F, 0x00, 0x18, 0x38, 0x78, 0x78, 0xF8, 0xF8, 0xF0, 0xF0, 0xF8, 0xF8, 0x78, 0x78, 0x38, 0x18, 0x00, // 48
    0x78, 0x78, 0x78, 0x7C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0xF0, 0xF0, 0xF0, 0xF0, 0xF8, 0xF8, 0xF8, 0xF8, 0xF8, 0xF0, 0xF0, 0xF0, 0xF0, // 49
    0x00, 0x3E, 0x1E, 0x1E, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x1F, 0xFF, 0xFE, 0xFE, 0xFC, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x80, 0xC0, 0xE0, 0xF0, 0xF8, 0xFC, 0x7E, 0x3F, 0x1F, 0x0F, 0x07, 0x01, 0x00, 0xF0, 0xF8, 0xF8, 0xF8, 0xF8, 0xF8, 0xF8, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, // 50
    0x00, 0x3E, 0x1E, 0x1E, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x9F, 0xFF, 0xFE, 0xFE, 0xFC, 0x78, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x1F, 0xFF, 0xFD, 0xFD, 0xF8, 0xF0, 0x78, 0x78, 0x78, 0xF8, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF8, 0xF8, 0x78, 0x78, 0x38, 0x18, 0x08, // 51
    0x00, 0x00, 0x00, 0x00, 0xC0, 0xE0, 0xF0, 0x78, 0x3E, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0xF8, 0xFC, 0xFE, 0xFF, 0xF7, 0xF3, 0xF1, 0xF0, 0xF0, 0xF0, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF0, 0xF0, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0xF8, 0xF8, 0xF8, 0xF8, 0x00, 0x00, 0x00, // 52
    0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x0F, 0x0F, 0x0F, 0x00, 0x80, 0x0F, 0x0F, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x0F, 0x0F, 0xFF, 0xFF, 0xFF, 0xFE, 0xF8, 0x78, 0x78, 0xF8, 0xF8, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF8, 0xF8, 0x78, 0x78, 0x38, 0x18, 0x00, // 53
    0x80, 0xE0, 0xF8, 0xFC, 0xFC, 0x7E, 0x3E, 0x9F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x0F, 0x1F, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x87, 0x07, 0x07, 0x07, 0x07, 0x07, 0x0F, 0xFF, 0xFF, 0xFF, 0xFE, 0xF8, 0x00, 0x18, 0x38, 0x78, 0x78, 0xF8, 0xF8, 0xF0, 0xF0, 0xF0, 0xF0, 0xF8, 0x78, 0x78, 0x38, 0x18, 0x00, // 54
    0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0x7F, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x80, 0xE0, 0xF8, 0xFC, 0xFF, 0xFF, 0x3F, 0x0F, 0x07, 0x01, 0x00, 0x00, 0x00, 0x80, 0xE0, 0xF0, 0xF8, 0xF8, 0xF8, 0x78, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // 55
    0x00, 0xF8, 0xFC, 0xFE, 0xFE, 0xFF, 0x9F, 0x8F, 0x0F, 0x0F, 0x0F, 0x1F, 0xFF, 0xFE, 0xFE, 0xFC, 0x78, 0x00, 0xE0, 0xF0, 0xF9, 0xFB, 0xFF, 0x1F, 0x0F, 0x0F, 0x0F, 0x0F, 0x1F, 0x1F, 0x3F, 0xFF, 0xFD, 0xF8, 0xF8, 0xE0, 0x08, 0x38, 0x78, 0x78, 0x78, 0xF8, 0xF8, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF8, 0x78, 0x78, 0x38, 0x38, 0x08, // 56
    0xE0, 0xF8, 0xFC, 0xFE, 0xFE, 0x1F, 0x0F, 0x0F, 0x0F, 0x0F, 0x1F, 0x3F, 0xFE, 0xFE, 0xFC, 0xF8, 0xE0, 0x03, 0x0F, 0x1F, 0x1F, 0x3F, 0x3E, 0x3C, 0x3C, 0x3C, 0x3C, 0x9C, 0xDC, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0x00, 0x00, 0xF8, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF8, 0x78, 0x78, 0x38, 0x38, 0x18, 0x00, 0x00, // 57
    0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x07, 0x07, 0x07, 0x07, 0x07, 0xF8, 0xF8, 0xF8, 0xF8, 0xF8, // 58
    0x38, 0x44, 0x44, 0x44, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00// 59 o
    
};

#endif
